package aacs.math;

import aacs.shared.Utils;

import javax.crypto.SecretKey;
import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import javax.crypto.spec.IvParameterSpec;


public class AESFunc {

    static byte[] AESCBCConstantIV   = Utils.hexStringToByteArray("0BA0F8DDFEA61FB3D8DF9F566A050F78");
    static IvParameterSpec IV = new IvParameterSpec(AESCBCConstantIV);
    static Cipher AES=null;
    static Cipher AESG=null;

    static{
        try{
            AES =Cipher.getInstance("AES/CBC/NOPADDING");
            AESG=Cipher.getInstance("AES/ECB/NOPADDING");
        }catch(Exception e){
            e.printStackTrace();
        }
    }

    public static byte[] AESG(byte[] x1, byte[] x2){
        SecretKey AESKey = new SecretKeySpec(x1,0,16,"AES");
        try{
        AESG.init(Cipher.DECRYPT_MODE,AESKey);
        byte[] out=AESG.doFinal(x2);

        return Utils.xor(out,x2);

        }catch(Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public static byte[] decryptPack(byte[] pack,byte[] contentKey){
        SecretKey AESKey = new SecretKeySpec(contentKey,0,16,"AES");
        try{
        AES.init(Cipher.DECRYPT_MODE,AESKey,IV);
        byte[] result=AES.doFinal(pack);
        return result;
        }catch(Exception e){
            e.printStackTrace();
        }
        return null;
    }

}
